# mpichgm-1.2.7..20.tar.gz
%define releasebase 1
%define mpichver 1.2.7p1
%define gmver 20 
%define prefix /opt/mpi/myrinet
%define fullname %{name}-%{version}

# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc



# NOTE: compiler choices are mutially exclusive, only set one.
%define use_gnu3   0 
%define use_gnu4  1
%define use_pgi  0
%define use_intel 0

%define nbase mpichgm

# allow --with[out] <feature> at rpm command line build
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}

#pick the target Limulus is default
%if "1" == "%{as_basement}"
%define moduleroot      /opt/mpi/tcp/%{name}
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define moduleroot      %{afsroot}/%{afsarch}/opt/mpi/tcp/%{name}
%define targetbase afs_%{afsarch}
%else
%define moduleroot      /opt/mpi/tcp/%{name}
%define targetbase Limulus
%endif
%endif


%define _gmarch linux_ia32
%ifarch x86_64
%define _gmarch linux_x86_64
%endif

# is there a better way to do this?
%if "1" == "%{use_pgi}"
Name: %{nbase}-pgi
%else
%if "1" == "%{use_intel}"
Name: %{nbase}-intel
%else
%if "1" == "%{use_gnu4}"
Name: %{nbase}-gnu4
%else
%if "1" == "%{use_gnu3}"
Name: %{nbase}-gnu3
%else
Name: %{nbase}
echo "No compiler Defined in Spec File"
exit
%endif
%endif 
%endif 
%endif 

Summary:  mpich-gm - an mpi library with support for myrinet's gm driver
Version: %{mpichver}..%{gmver}
Source: mpichgm-%{PACKAGE_VERSION}.tar.gz
License: Copyright Basement Supercomputing (basement-supercomputing.com)
Group: Cluster/MPI
URL: http://www.myri.com/scs/index.html
Vendor: Basement Supercomputing
Requires:  gm
Release: %{releasebase}.%{targetbase}
Prefix: %{prefix}
%define ver %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}

%description
MPI (which stands for Message Passing Interface) is a standard for
writing message-passing programs.  As such the interface attempts to
establish a practical, portable, efficient, and flexible standard for
message passing.

This version has support for the gm communication method, for direct 
access to a myrinet network.

%prep
%setup -n %{nbase}-%{version}

%build
%define GM_HOME /usr/gm
%define PREFIX $RPM_BUILD_ROOT
%define RSHCOMMAND ssh

#fix the scripts for gcc build
%if "1" == "%{use_gnu4}" ||  "1" == "%{use_gnu3}"
  /bin/cp mpich.make.gcc mpich.make.gcc.install
  sed 's!setenv GM_HOME /opt/gm!setenv GM_HOME /usr/gm!g' mpich.make.gcc.install > mpich.make.gcc
  /bin/rm mpich.make.gcc.install
  /bin/cp mpich.make.gcc mpich.make.gcc.install
  sed 's!setenv PREFIX /opt/mpi!setenv PREFIX %{?buildroot:%{buildroot}}/opt/mpi/myrinet/%{name}-%{PACKAGE_VERSION}!g' mpich.make.gcc.install > mpich.make.gcc
  /bin/rm mpich.make.gcc.install
  # remove -rpath stuff
  /bin/cp mpich.make.gcc mpich.make.gcc.install
  sed 's!-Wl,-rpath,$GM_HOME/lib,$GM_HOME/lib64!!g' mpich.make.gcc.install > mpich.make.gcc
  /bin/rm mpich.make.gcc.install
#gnu4 uses g95 and fix config problem
  %if "1" == "%{use_gnu4}"
    /bin/cp mpich.make.gcc mpich.make.gcc.install
    sed 's!setenv FC g77!setenv FC gfortran;setenv F77_GETARGDECL " "!g' mpich.make.gcc.install > mpich.make.gcc
    /bin/rm mpich.make.gcc.install
  %endif
%endif


%if "1" == "%{use_intel}"
  %ifnarch x86_64
    ./mpich.make.intel_ia32
  %endif
  %ifarch x86_64
    ./mpich.make.intel_ia64
  %endif
%else
%if "1" == "%{use_pgi}"
  /bin/cp mpich.make.pgi mpich.make.pgi.install
  sed 's!setenv GM_HOME /opt/gm!setenv GM_HOME /usr/gm!g' mpich.make.pgi.install > mpich.make.pgi
  /bin/rm mpich.make.pgi.install
  /bin/cp mpich.make.pgi mpich.make.pgi.install
  sed 's!setenv PREFIX /opt/mpich-gm!setenv PREFIX %{?buildroot:%{buildroot}}/opt/mpi/myrinet/%{name}-%{PACKAGE_VERSION}!g' mpich.make.pgi.install > mpich.make.pgi
  /bin/rm mpich.make.pgi.install
  /bin/cp mpich.make.pgi mpich.make.pgi.install
  sed 's!setenv PGI_FLAGS "-tp px"!setenv PGI_FLAGS "-fast"!g' mpich.make.pgi.install > mpich.make.pgi
  /bin/rm mpich.make.pgi.install
  /bin/cp mpich.make.pgi mpich.make.pgi.install
  sed 's!-lib="-L$GM_HOME/lib/ -lgm"!-lib="-L$GM_HOME/lib/ -L$GM_HOME/lib64/ -lgm"!g' mpich.make.pgi.install > mpich.make.pgi
  /bin/rm mpich.make.pgi.install
  . /etc/profile.d/modules.sh
  module load pgi62
  ./mpich.make.pgi
%else
%if "1" == "%{use_gnu3}"
  ./mpich.make.gcc
  %else
%if "1" == "%{use_gnu4}"
  ./mpich.make.gcc
%else
  echo "No compiler Defined in Spec File"
  exit
%endif
%endif
%endif
%endif


%install
# Fix the paths in the shell scripts
%define BUILD_PATH  %{?buildroot:%{buildroot}}%{prefix}/%{name}-%{PACKAGE_VERSION}
%define INSTALL_PATH  %{prefix}/%{name}-%{PACKAGE_VERSION}
fix="mpirun mpirun.save mpicxx mpicc mpiman mpif77 mpif90  mpireconfig.dat mpichboot mpichstop mpireconfig mpirun.ch_gm.pl"
for i in $fix
do
 /bin/cp %{BUILD_PATH}/bin/$i   %{BUILD_PATH}/bin/$i.install
 sed "s!%{BUILD_PATH}!%{INSTALL_PATH}!g"  %{BUILD_PATH}/bin/$i.install >  %{BUILD_PATH}/bin/$i
 /bin/rm  %{BUILD_PATH}/bin/$i.install
done

#Remove the symlink to mpirun in examples
/bin/rm  %{?buildroot:%{buildroot}}/%{prefix}/%{name}-%{PACKAGE_VERSION}/share/examples/mpirun
%post

# assume we are the "prefered" mpich-gm
cd %{prefix}
ln -snbf %{name}-%{PACKAGE_VERSION} %{name}
# now make the module file
/bin/mkdir -p /opt/Modules/modulefiles/mpi
cat <<EOF >/opt/Modules/modulefiles/mpi/%{name}
#%Module1.0#######################################################################
## mpi/mpichgm modulefile
##
## Copyright (c) 2006 Basement Supercomputing

conflict mpi

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing mpi/%{name}.\n"
}

module-whatis "mpi/%{name}"
module-log error none

set currentmod \$env(HOME)/.currentmodules
set currentstring "module load mpi/%{name}"
set mpiroot /opt/mpi/myrinet/%{name}
if [ module-info mode load ] {
        setenv MPICH_HOME \$mpiroot
        append-path MANPATH \$mpiroot/man
        prepend-path PATH \$mpiroot/bin
        prepend-path  LD_LIBRARY_PATH \$mpiroot/lib
        if { ! [catch {open \$currentmod {RDWR CREAT}} usermod]} {
                set all [read \$usermod]
                if { ! [ regexp \$currentstring \$all ]} {
                        puts \$usermod \$currentstring
                }
                close \$usermod
        }
}
if [ module-info mode remove ] {
        remove-path MANPATH \$mpiroot/man
        remove-path PATH \$mpiroot/bin
        remove-path LD_LIBRARY_PATH \$mpiroot/lib
        unsetenv MPICH_HOME
        if { ! [catch {open \$currentmod r} userdel]} {
                set output ""
                foreach line [split [read \$userdel] \n] {
                        if { \$line!={} && ! [regexp [append currentstring "$"] \$line]} {
                                append output \$line "\n"
                        }
                }
                close \$userdel
        }
        if { ! [catch {open \$currentmod w} userdel]} {
                puts \$userdel \$output
                close \$userdel
        }
}
EOF

%postun
/sbin/ldconfig 2>/dev/null
/bin/rm /opt/Modules/modulefiles/mpi/%{name}


%files
%defattr(-,root,root)
%{prefix}/%{name}-%{PACKAGE_VERSION}/bin
%{prefix}/%{name}-%{PACKAGE_VERSION}/doc
%{prefix}/%{name}-%{PACKAGE_VERSION}/etc
%{prefix}/%{name}-%{PACKAGE_VERSION}/examples
%{prefix}/%{name}-%{PACKAGE_VERSION}/include 
%{prefix}/%{name}-%{PACKAGE_VERSION}/lib
%{prefix}/%{name}-%{PACKAGE_VERSION}/man
%{prefix}/%{name}-%{PACKAGE_VERSION}/sbin
%{prefix}/%{name}-%{PACKAGE_VERSION}/www
%{prefix}/%{name}-%{PACKAGE_VERSION}/logfiles
%{prefix}/%{name}-%{PACKAGE_VERSION}/share/examples
%{prefix}/%{name}-%{PACKAGE_VERSION}/share/machines.sample
%{prefix}/%{name}-%{PACKAGE_VERSION}/share/Makefile.sample
%{prefix}/%{name}-%{PACKAGE_VERSION}/share/machines.ch_gm.LINUX
%doc doc/*  README* www www.index romio/doc/users-guide.ps.gz

%clean
if [ %{?buildroot:%{buildroot}} != "/" ]; then
  rm -rf %{?buildroot:%{buildroot}}
fi

%define date    %(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
 
